`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   13:05:04 05/05/2006
// Design Name:   hw_accel_top
// Module Name:   C:/Data/Projects/Virtex_5_designs/V5_RAID6/hw_accelerator/raid_top_testbench_with_dimm\.v
// Project Name:  hw_accelerator
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: hw_accel_top
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 100ps

module raid_top_testbench_with_dimm;

	// Inputs
      reg         clk_p;
	reg         clk_n;

      reg         reset;
	reg   [7:0] control;
      reg         inject_n;


	reg         clk200_p;
	reg         clk200_n;
	wire [63:0] ddr2_dq;
	wire  [7:0] ddr2_dqs;
	wire  [7:0] ddr2_dqs_n;
	wire  [7:0] ddr2_dm;
	wire  [1:0] ddr2_clk;
	wire  [1:0] ddr2_clk_n;
	wire [13:0] ddr2_address;
	wire  [1:0] ddr2_ba;
	wire        ddr2_ras_L;
	wire        ddr2_cas_L;
	wire        ddr2_we_L;
	wire  [0:0] ddr2_cs;
	wire  [0:0] ddr2_cke;

      wire  [0:0] ddr2_odt;

 

	// Instantiate the Unit Under Test (UUT)
hw_accel_top test_unit (
           // .clk_p      (clk_p),
           // .clk_n      (clk_n),
           // .mem_clk_p  (clk_p),
           // .mem_clk_n  (clk_n),
            .rst_n      (reset), 
         //   .control    (control),
            .status     (), 

            .inject_n          (inject_n),


            .SYS_CLK_N         (clk_p), 
            .SYS_CLK_P         (clk_n),
            .CLK200_N          (clk200_p),
            .CLK200_P          (clk200_n),
            .SYS_RESET_IN      (sys_rst_in),
            .DDR2_RAS_N        (ddr2_ras_L),
            .DDR2_CAS_N        (ddr2_cas_L),
            .DDR2_WE_N         (ddr2_we_L),
            .DDR2_ODT          (ddr2_odt),
            .DDR2_CKE          (ddr2_cke),
            .DDR2_CS_N         (ddr2_cs),
            .DDR2_DQ           (ddr2_dq),
            .DDR2_DQS          (ddr2_dqs),
            .DDR2_DQS_N        (ddr2_dqs_n),
            .DDR2_DM           (ddr2_dm),
            .DDR2_CK           (ddr2_clk),
            .DDR2_CK_N         (ddr2_clk_n),
            .DDR2_BA           (ddr2_ba),
            .DDR2_A            (ddr2_address)
            );
		
ddr2_sodimm ml555_ddr2(

.clk0    (ddr2_clk),
.clk0_n  (ddr2_clk_n),
.clk1    (ddr2_clk),
.clk1_n  (ddr2_clk_n),
.cke     (ddr2_cke),
.cs_n    (ddr2_cs),
.ras_n   (ddr2_ras_L),
.cas_n   (ddr2_cas_L),
.we_n    (ddr2_we_L),
.dm_rdqs (ddr2_dm),//8
.s_n     (ddr2_cs),
.ba      (ddr2_ba),//3
.a       (ddr2_address[12:0]),//13
.dq      (ddr2_dq),//64
.dqs     (ddr2_dqs),//8
.dqs_n   (ddr2_dqs_n),//8
.rdqs_n  (),
.odt     (ddr2_odt)
);



	initial begin
		// Initialize Inputs
            clk_n = 0;
            clk_p = 1;

            clk200_n = 0;
            clk200_p = 1;

		reset = 0;
		control = 0;
            inject_n = 1;

		// Wait 800 ns for global reset to finish
		//#100;
		//reset = 0;
		#1600;
		reset = 1;
            #382000;
            inject_n = 0;
            #600;
            inject_n = 1;


		
       
		// Add stimulus here

	end
	
	   always #2.5 clk_n = ~clk_n;
	   always #2.5 clk_p = ~clk_p; 

	   always #2.5 clk200_n = ~clk200_n;
	   always #2.5 clk200_p = ~clk200_p;     
endmodule

