//------------------------------------------------------------------------------ 
// Copyright (c) 2007 Xilinx, Inc. 
// All Rights Reserved 
//------------------------------------------------------------------------------ 
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /   Vendor: Xilinx 
// \   \   \/    Author: Xilinx, Inc.
//  \   \        Filename: ADDSUB48
//  /   /        Date Last Modified:  Feb 05, 2007 
// /___/   /\    Date Created: OCTOBER 05, 2004 
// \   \  /  \ 
//  \___\/\___\ 
// 
//
// Revision History: 
// $Log: $
//------------------------------------------------------------------------------ 
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//------------------------------------------------------------------------------ 
/**********************************************************************/
//
// Module: ADDSUB48
//
// Description: Verilog fabric implementaion for 
// 4 i-bit adders
//  
// 
// 
// 
//
// 
//
// Copyright (c) 2007 Xilinx, Inc.  All rights reserved.
//
////////////////////////////////////////////////////////////////////////////////////
//


module ADDSUB48 (CLK, RST, C_IN, PC_IN, ADD_SUB, ADDSUB_OUT);
	
input  wire          CLK, RST;
input  wire  [47:0]  C_IN, PC_IN;
input  wire          ADD_SUB;
output reg   [47:0]  ADDSUB_OUT;

wire         [47:0]  ADDSUB;

assign ADDSUB[8:0] = C_IN[7:0] + PC_IN[7:0];
assign ADDSUB[17:9] = C_IN[17:9] + PC_IN[17:9];
assign ADDSUB[26:18] = C_IN[26:18] + PC_IN[26:18];
assign ADDSUB[35:27] = C_IN[35:27] + PC_IN[35:27];
assign ADDSUB[47:36] = 12'h000;

always @(posedge CLK or posedge RST)
begin
  if(RST)
  begin
    ADDSUB_OUT <= 48'h000000;
  end
  else
  begin
    ADDSUB_OUT <= ADDSUB;
  end
end

endmodule





