///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2005 Xilinx, Inc.
// This design is confidential and proprietary of Xilinx, All Rights Reserved.
///////////////////////////////////////////////////////////////////////////////
//   ____  ____
//  /   /\/   /
// /___/  \  / Vendor: Xilinx
// \   \   \/ Version: 1.6
//  \   \ Application : MIG
//  /   / Filename:mem.v
// /___/   /\Date Last Modified:  Wed Jun 1 2005
// \   \  /  \Date Created: Mon May 2 2005
//  \___\/\___\
//Device: Virtex-5
//Design Name: DDR2_V5
//Description     : This module is the top most module which interfaces with  
//                  the system and the memory.
///////////////////////////////////////////////////////////////////////////////

`timescale 1ns/1ps

module mem(
//MD inout  [71:0]  cntrl0_DDR2_DQ,
//this was changed to work on ML555
inout  [63:0]  cntrl0_DDR2_DQ,
output  [13:0]  cntrl0_DDR2_A,
output  [1:0]  cntrl0_DDR2_BA,
output  cntrl0_DDR2_RAS_N,
output  cntrl0_DDR2_CAS_N,
output  cntrl0_DDR2_WE_N,
output  cntrl0_DDR2_RESET_N,
output  [0:0]  cntrl0_DDR2_CS_N,
output  [0:0]  cntrl0_DDR2_ODT,
output  [0:0]  cntrl0_DDR2_CKE,
output  [7:0]  cntrl0_DDR2_DM,
input  SYS_CLK_P,
input  SYS_CLK_N,
output SYS_BUF_CLK,
input  CLK200_P,
input  CLK200_N,
input  SYS_RESET_IN,
output SYS_RST_FROM_MEM_CTRL,
output CLK_0_FROM_MEM_CTRL_DCM,
output CLK_DV_FROM_MEM_CTRL_DCM,
output  cntrl0_phy_init_initialization_done,
output  cntrl0_WDF_ALMOST_FULL,
output  cntrl0_AF_ALMOST_FULL,
output  cntrl0_READ_DATA_VALID,
input  cntrl0_APP_WDF_WREN,
input  cntrl0_APP_AF_WREN,
output  [2:0]  cntrl0_BURST_LENGTH,
input  [35:0]  cntrl0_APP_AF_ADDR,
//output  [143:0]  cntrl0_READ_DATA_FIFO_OUT,
//input  [143:0]  cntrl0_APP_WDF_DATA,
//input  [17:0]  cntrl0_APP_MASK_DATA,
//these were changed to work on ML555
output  [127:0]  cntrl0_READ_DATA_FIFO_OUT,
input  [127:0]  cntrl0_APP_WDF_DATA,
input  [15:0]  cntrl0_APP_MASK_DATA,

//inout  [8:0]  cntrl0_DDR2_DQS,
//inout  [8:0]  cntrl0_DDR2_DQS_N,
//output  [0:0]  cntrl0_DDR2_CK,
//output  [0:0]  cntrl0_DDR2_CK_N
//these were changed to work on ML555
inout  [7:0]  cntrl0_DDR2_DQS,
inout  [7:0]  cntrl0_DDR2_DQS_N,
output  [1:0]  cntrl0_DDR2_CK,
output  [1:0]  cntrl0_DDR2_CK_N
);


wire  sys_rst ;
assign  SYS_RST_TB = sys_rst;
wire  sys_rst90 ;
wire  sys_rst200 ;
wire  idelay_ctrl_rdy ;
wire  clk_0 ;
wire  clk_dv;
assign  CLK_0_FROM_MEM_CTRL_DCM = clk_0;
assign  CLK_DV_FROM_MEM_CTRL_DCM = clk_dv;
assign SYS_RST_FROM_MEM_CTRL = sys_rst90;
wire  clk_90 ;
wire  clk_200 ;

mem_idelay_ctrl  mem_idelay_ctrl(
.sys_rst200(sys_rst200),
.idelay_ctrl_rdy(idelay_ctrl_rdy),
.clk_200(clk_200)
);

mem_infrastructure  mem_infrastructure(
.SYS_CLK_P(SYS_CLK_P),
.SYS_CLK_N(SYS_CLK_N),
.SYS_BUF_CLK(SYS_BUF_CLK),
.CLK200_P(CLK200_P),
.CLK200_N(CLK200_N),
.SYS_RESET_IN(SYS_RESET_IN),
.sys_rst(sys_rst),
.sys_rst90(sys_rst90),
.sys_rst200(sys_rst200),
.clk_0(clk_0),
.clk_dv(clk_dv),
.clk_90(clk_90),
.clk_200(clk_200)
);

mem_top_0  mem_top_0(
.DDR2_DQ(cntrl0_DDR2_DQ),
.DDR2_A(cntrl0_DDR2_A),
.DDR2_BA(cntrl0_DDR2_BA),
.DDR2_RAS_N(cntrl0_DDR2_RAS_N),
.DDR2_CAS_N(cntrl0_DDR2_CAS_N),
.DDR2_WE_N(cntrl0_DDR2_WE_N),
.DDR2_RESET_N(cntrl0_DDR2_RESET_N),
.DDR2_CS_N(cntrl0_DDR2_CS_N),
.DDR2_ODT(cntrl0_DDR2_ODT),
.DDR2_CKE(cntrl0_DDR2_CKE),
.DDR2_DM(cntrl0_DDR2_DM),
.sys_rst(sys_rst),
.sys_rst90(sys_rst90),
.idelay_ctrl_rdy(idelay_ctrl_rdy),
.clk_0(clk_0),
.clk_90(clk_90),
.clk_200(clk_200),
.phy_init_initialization_done(cntrl0_phy_init_initialization_done),
.WDF_ALMOST_FULL(cntrl0_WDF_ALMOST_FULL),
.AF_ALMOST_FULL(cntrl0_AF_ALMOST_FULL),
.READ_DATA_VALID(cntrl0_READ_DATA_VALID),
.APP_WDF_WREN(cntrl0_APP_WDF_WREN),
.APP_AF_WREN(cntrl0_APP_AF_WREN),
.BURST_LENGTH(cntrl0_BURST_LENGTH),
.APP_AF_ADDR(cntrl0_APP_AF_ADDR),
.READ_DATA_FIFO_OUT(cntrl0_READ_DATA_FIFO_OUT),
.APP_WDF_DATA(cntrl0_APP_WDF_DATA),
.APP_MASK_DATA(cntrl0_APP_MASK_DATA),
.DDR2_DQS(cntrl0_DDR2_DQS),
.DDR2_DQS_N(cntrl0_DDR2_DQS_N),
.DDR2_CK(cntrl0_DDR2_CK),
.DDR2_CK_N(cntrl0_DDR2_CK_N)
);

endmodule