//////////////////////////////////////////////////////////////////////////////// 
// Copyright (c) 2007 Xilinx, Inc. 
// All Rights Reserved 
//////////////////////////////////////////////////////////////////////////////// 
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /         Vendor: Xilinx 
// \   \   \/          Version: 1.1
//  \   \              Filename: hard2_code_mux.v 
//  /   /              Date Last Modified: 2/22/2007
// /___/   /\          Date Created: 10/22/2005  
// \   \  /  \ 
//  \___\/\___\ 
// 
//Design Name: hard2_code_mux 
//Purpose:  This module is a mux for one set of G constants using an inverse
//          for the Double Data recovery scenario
//          
//          This is part of XAPP 731 and XAPP 865
//
////////////////////////////////////////////////////////////////////////////////
// 
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//
////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps

module hard2_code_mux(
input	 wire  [3:0] select, 
output wire  [7:0] hard_data);

//these are the g-type values that do the g inverse values after looked up in a gflog table
//to find two data disks 
// for larger disk arrays will require a larger mux or a different implementation
assign hard_data = select[3] ?
                     (select[0] ? (select[1] ? 
                                    (select[2] ? 8'hZZ : 8'hZZ) : 
                                    (select[2] ? 8'hZZ : 8'he6)) : 
                                 (select[1] ? 
                                    (select[2] ? 8'hZZ : 8'hce) : 
                                    (select[2] ? 8'hZZ : 8'he7))) : 
                     (select[0] ? (select[1] ? 
                                    (select[2] ? 8'hZZ : 8'hfd) : 
                                    (select[2] ? 8'hZZ : 8'hff)) : 
                                 (select[1] ? 
                                    (select[2] ? 8'hZZ : 8'hfe) : 
                                    (select[2] ? 8'hfc : 8'h00))) ;

endmodule
