//////////////////////////////////////////////////////////////////////////////// 
// Copyright (c) 2007 Xilinx, Inc. 
// All Rights Reserved 
//////////////////////////////////////////////////////////////////////////////// 
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /         Vendor: Xilinx 
// \   \   \/          Version: 1.1
//  \   \              Filename: hard_code_mux.v 
//  /   /              Date Last Modified: 2/21/2007
// /___/   /\          Date Created: 10/21/2005  
// \   \  /  \ 
//  \___\/\___\ 
// 
//Design Name: hard_code_mux 
//Purpose:  This module selects different g constants for the RAID_MULT_4 blocks
//          
//          This is part of XAPP 731 and XAPP865
//
////////////////////////////////////////////////////////////////////////////////
// 
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//
//
////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps

module hard_code_mux(
input	 wire  [2:0] select, 
output wire  [7:0] hard_data);

//these are the g values after looked up in a gflog table
//to find two data disks will require a larger mux or a different inplementation
assign hard_data = select[0] ? (select[1] ? 
                                    (select[2] ? 8'h00 : 8'h03) : 
                                    (select[2] ? 8'hZZ : 8'h01)) : 
                               (select[1] ? 
                                    (select[2] ? 8'hZZ : 8'h02) : 
                                    (select[2] ? 8'h04 : 8'h00)) ;

endmodule
